-- The code is a mess right now, cleanup coming soon

tbx = {}

tbx.debug = false
tbx.version = tonumber(Inspect.Addon.Detail(Inspect.Addon.Current()).toc.Version)

tbx.selectedItems = {}
tbx.clipboard = {}
tbx.groupClipboard = {}
tbx.itemList = {}
tbx.constructions = {}
--tbx.itemQueue = {}
--tbx.queuePaused = true

-- Main Function
function tbx.main()
  -- Command handler
  table.insert (Command.Slash.Register("toolbox"), {tbx.commandHandler, "tbx", "Toolbox Command"})
  if Event.Dimension ~= nil and Inspect.Dimension ~= nil then
    table.insert (Event.Dimension.Layout.Add, {tbx.addEventHandler, "tbx", "Update selection"})
    table.insert (Event.Dimension.Layout.Remove, {tbx.removeEventHandler, "tbx", "Update selection"})
    table.insert (Event.Dimension.Layout.Update, {tbx.updateEventHandler, "tbx", "Update selection"})
  else
    print("This addon is intended for use with Dimensions, which are currently only available on the BETA server until Storm Legion hits live.")
  end
  --table.insert (Event.Dimension.Layout.Add, {function() tbx.dbg("Add event fired") end, "tbx", "Update selection"})
  --table.insert (Event.Dimension.Layout.Remove, {function() tbx.dbg("Remove event fired") end, "tbx", "Update selection"})
  --table.insert (Event.Dimension.Layout.Update, {function() tbx.dbg("Update event fired") end, "tbx", "Update selection"})
  
  tbx.dbg("Debugging Enabled")
end

function tbx.addEventHandler()
  --tbx.dbg("Add event fired")
  tbx.updateSelection()
end

function tbx.removeEventHandler()
  --tbx.dbg("Remove event fired")
  tbx.updateSelection()
end

function tbx.updateEventHandler()
  --tbx.dbg("Update event fired")
  tbx.updateSelection()
  --tbx.processQueue()
end

function tbx.updateSelection()
  if tbx.ui ~= nil and tbx.ui.active and Event.Dimension ~= nil and Inspect.Dimension ~= nil then
    --tbx.dbg("Selection updated")
    local items = Inspect.Dimension.Layout.Detail(Inspect.Dimension.Layout.List())
    tbx.selectedItems = {}
    if items ~= nil then
      for _, details in pairs(items) do
        if details.selected then 
          table.insert(tbx.selectedItems, details)
        end
      end
    end
    if #tbx.selectedItems < 1 then
      tbx.ui.needsReset = true
    end
    --if #tbx.selectedItems == 1 then tbx.dbg(tbx.selectedItems[1].name) end
    tbx.ui.updateItemDetails() -- temporary
  end
end

-- Set position of all items
function tbx.setItemPositions(x, y, z, relative, groupMode)
  if #tbx.selectedItems > 0 then
    if not relative and groupMode and #tbx.selectedItems > 1 then -- group move
      local cp = tbx.getCentralPoint(tbx.selectedItems)
      for k, details in pairs(tbx.selectedItems) do
        local newX, newY, newZ
        if x == nil or x == "" then newX = details.coordX else newX = x + (details.coordX - cp.x) end
        if y == nil or y == "" then newY = details.coordY else newY = y + (details.coordY - cp.y) end
        if z == nil or z == "" then newZ = details.coordZ else newZ = z + (details.coordZ - cp.z) end
        tbx.setItemPosition(k, newX, newY, newZ, false)
      end
    else
      for k, details in pairs(tbx.selectedItems) do
        tbx.setItemPosition(k, x, y, z, relative)
      end
    end
  end
end

-- Reset position of all items to in front of the user
function tbx.resetItemPositions()
  if #tbx.selectedItems > 0 then
    local player = Inspect.Unit.Detail("player")
    for k, details in pairs(tbx.selectedItems) do
      tbx.setItemPosition(k, player.coordX + 4, player.coordY + 1, player.coordZ, false)
    end
  end
end

-- Set rotation of all items
function tbx.setItemRotations(yaw, pitch, roll, relative)
  if #tbx.selectedItems > 0 then
    for k, details in pairs(tbx.selectedItems) do
      tbx.setItemRotation(k, yaw, pitch, roll, relative)
    end
  end
end

-- Reset rotation of all items to 0
function tbx.resetItemRotations()
  if #tbx.selectedItems > 0 then
    for k, details in pairs(tbx.selectedItems) do
      tbx.setItemRotation(k, 0, 0, 0, false)
    end
  end
end

-- Set scale of all items
function tbx.setItemScales(scale, relative)
  if #tbx.selectedItems > 0 then
    for k, details in pairs(tbx.selectedItems) do
      tbx.setItemScale(k, scale, relative)
    end
  end
end

-- Reset scale of all items to 0
function tbx.resetItemScales()
  if #tbx.selectedItems > 0 then
    for k, details in pairs(tbx.selectedItems) do
      tbx.setItemScale(k, 1, false)
    end
  end
end

-- Set position of a single item
function tbx.setItemPosition(index, x, y, z, relative)
  if tbx.selectedItems[index] ~= nil then
    local newPlacement = {}
    if relative ~= nil and relative then -- relative positioning
      if x == nil or x == "" then x = 0 end
      if y == nil or y == "" then y = 0 end
      if z == nil or z == "" then z = 0 end
      
      if not tonumber(x) or
         not tonumber(y) or
         not tonumber(z) then
        print("Please enter numeric values only")
        return
      end
      
      newPlacement = {coordX = tbx.selectedItems[index].coordX + tonumber(x), coordY = tbx.selectedItems[index].coordY + tonumber(y), coordZ = tbx.selectedItems[index].coordZ + tonumber(z)}
    else -- absolute positioning
      if x == nil or x == "" then x = tbx.selectedItems[index].coordX end
      if y == nil or y == "" then y = tbx.selectedItems[index].coordY end
      if z == nil or z == "" then z = tbx.selectedItems[index].coordZ end
      
      if not tonumber(x) or
         not tonumber(y) or
         not tonumber(z) then
        print("Please enter numeric values only")
        return
      end
      
      newPlacement = {coordX = tonumber(x), coordY = tonumber(y), coordZ = tonumber(z)}
    end
    
    local test = Command.Dimension.Layout.Place(tbx.selectedItems[index].id, newPlacement)
    tbx.dbg(test)
  else
    print("Please select an item in order to modify its position")
  end
end

--[[
function tbx.rotateAsGroup(yaw, pitch, roll, relative)
  if tbx.numItemsSelected > 0 then
    local centralPoint = tbx.getCentralPoint(tbx.selectedItems)
    --tbx.dbg("%.4f, %.4f, %.4f", centralPoint.x, centralPoint.y, centralPoint.z)
    for k, details in pairs(tbx.selectedItems) do
      local itemPoint = {x = details.coordX, y = details.coordY, z = details.coordZ}
      
      local s = math.sin(yaw);
      local c = math.cos(yaw);

      itemPoint.x = itemPoint.x - centralPoint.x;
      itemPoint.z = itemPoint.z - centralPoint.z;

      local newX = itemPoint.x * c - itemPoint.z * s;
      local newZ = itemPoint.x * s + itemPoint.z * c;

      itemPoint.x = newX + centralPoint.x
      itemPoint.z = newZ + centralPoint.z
      
      Command.Dimension.Layout.Move(details.id, itemPoint.x, itemPoint.y, itemPoint.z)
      Command.Dimension.Layout.Rotate(details.id, 0, 0, details.yaw + tonumber(yaw))
    end
  end
end
]]

function tbx.getCentralPoint(itemsList)
  local itemsList = itemsList or {}
  if #itemsList > 0 then
    local centralPoint = {x = 0, y = 0, z = 0}
    for k, details in pairs(itemsList) do
      centralPoint.x = centralPoint.x + details.coordX
      centralPoint.y = centralPoint.y + details.coordY
      centralPoint.z = centralPoint.z + details.coordZ
    end
    for k, v in pairs(centralPoint) do centralPoint[k] = v / #itemsList end
    return centralPoint
  end
end


function tbx.setItemRotation(index, yaw, pitch, roll, relative)
  if tbx.selectedItems[index] ~= nil then
    local newPlacement = {}
    if relative ~= nil and relative then -- relative positioning
      if yaw == nil or yaw == "" then yaw = 0 end
      if pitch == nil or pitch == "" then pitch = 0 end
      if roll == nil or roll == "" then roll = 0 end
      
      if not tonumber(yaw) or
         not tonumber(pitch) or
         not tonumber(roll) then
        print("Please enter numeric values only")
        return
      end
      
      yaw = tbx.toRadians(yaw)
      pitch = tbx.toRadians(pitch)
      roll = tbx.toRadians(roll)
      
      newPlacement = {["pitch"] = tbx.selectedItems[index].pitch + tonumber(pitch), ["yaw"] = tbx.selectedItems[index].yaw + tonumber(yaw), ["roll"] = tbx.selectedItems[index].roll + tonumber(roll)}
    else -- absolute positioning
      if yaw == nil or yaw == "" then yaw = tbx.selectedItems[index].yaw end
      if pitch == nil or pitch == "" then pitch = tbx.selectedItems[index].pitch end
      if roll == nil or roll == "" then roll = tbx.selectedItems[index].roll end
      
      if not tonumber(yaw) or
         not tonumber(pitch) or
         not tonumber(roll) then
        print("Please enter numeric values only")
        return
      end
      
      yaw = tbx.toRadians(yaw)
      pitch = tbx.toRadians(pitch)
      roll = tbx.toRadians(roll)
      
      newPlacement = {["pitch"] = tonumber(pitch), ["yaw"] = tonumber(yaw), ["roll"] = tonumber(roll)}
    end
    
    Command.Dimension.Layout.Place(tbx.selectedItems[index].id, newPlacement)
  else
    print("Please select an item in order to modify its rotation")
  end
end

function tbx.setItemScale(index, scale, relative)
  if tbx.selectedItems[index] ~= nil then
    local newPlacement = {}
    if relative ~= nil and relative then -- relative positioning
      if scale == nil or scale == "" then scale = 0 end
      
      if not tonumber(scale) then
        print("Please enter numeric values only")
        return
      end
      
      newPlacement = {scale = tbx.selectedItems[index].scale + tonumber(scale)}
    else -- absolute positioning
      if scale == nil or scale == "" then scale = tbx.selectedItems[index].scale end
      
      if not tonumber(scale) then
        print("Please enter numeric values only")
        return
      end
      
      newPlacement = {scale = tonumber(scale)}
    end
    
    Command.Dimension.Layout.Place(tbx.selectedItems[index].id, newPlacement)
  else
    print("Please select an item in order to modify its scale")
  end
end

function tbx.copyItemAttributes()
  if #tbx.selectedItems == 1 then
    tbx.clipboard = {
      x = tbx.selectedItems[1].coordX,
      y = tbx.selectedItems[1].coordY,
      z = tbx.selectedItems[1].coordZ,
      yaw = tbx.selectedItems[1].yaw,
      pitch = tbx.selectedItems[1].pitch,
      roll = tbx.selectedItems[1].roll,
      scale = tbx.selectedItems[1].scale,
    }
  elseif #tbx.selectedItems > 1 then
    print("Copy feature only works on single item selections at the moment")
  else
    print("Please select an item in order to copy attributes")
  end
end

--------------------------------------------------------------------------------
function tbx.saveGroupItemAttributes(name)
  if name ~= nil and name ~= "" then
    if #tbx.selectedItems > 0 then
      
      local groupDetails = {} -- Only save the necessary info
      for _, item in pairs(tbx.selectedItems) do
        table.insert(groupDetails, {name = item.name,
                                    type = item.type,
                                    coordX = item.coordX,
                                    coordY = item.coordY,
                                    coordZ = item.coordZ,
                                    yaw = item.yaw,
                                    pitch = item.pitch,
                                    roll = item.roll,
                                    scale = item.scale})
      end
      tbx.constructions[name] = groupDetails
      tbx.settings.set("savedConstructions", tbx.constructions)
      print(string.format("Item set \"%s\" saved", name))
    else
      print("Must select 1 or more items in order to save them")
    end
  else
    print("Must enter a name in order to save the set")
  end
end

function tbx.loadGroupItemAttributes(name, pasteAtOriginalLoc)
  if name ~= nil and name ~= "" then
    if tbx.constructions[name] ~= nil then
        tbx.groupClipboard = tbx.constructions[name]
        tbx.pasteGroup(pasteAtOriginalLoc)
    else
      print(string.format("Item set \"%s\" not found", name))
    end
  else
    print("You must select a set in order to load it")
  end
end

function tbx.removeGroupItem(name)
  if name ~= nil and name ~= "" then
    if tbx.constructions[name] ~= nil then
      tbx.constructions[name] = nil
      tbx.settings.set("savedConstructions", tbx.constructions)
      print(string.format("Item set \"%s\" removed", name))
    else
      print(string.format("Could not remove \"%s\" - no such item found", name))
    end
  else
    print("You must select a set in order to remove it")
  end
end

function tbx.getGroupShoppingList()
  if #tbx.groupClipboard > 0 then
    local shoppingList = {}
    for k, details in pairs(tbx.groupClipboard) do
      if shoppingList[tbx.groupClipboard[k].type] == nil then
        shoppingList[tbx.groupClipboard[k].type] = {name = tbx.groupClipboard[k].name, amount = 1}
      else
        shoppingList[tbx.groupClipboard[k].type].amount = shoppingList[tbx.groupClipboard[k].type].amount + 1
      end
    end
    return shoppingList
  end
end

function tbx.checkSelected(shoppingList)
  if #tbx.groupClipboard > 0 then
    tbx.itemList = {}
    for _, item in pairs(tbx.selectedItems) do
      if shoppingList[item.type] ~= nil then
        if tbx.itemList[item.type] == nil then
          tbx.itemList[item.type] = {item.id}
        else
          table.insert(tbx.itemList[item.type], item.id)
        end
        --table.insert(tbx.itemList[item.type], item.id)
        if shoppingList[item.type].amount == 1 then --if theres only 1 item left to get
          shoppingList[item.type] = nil -- remove the item from the shopping list (we have enough)
          --tbx.itemList[item.type] = item.id --add the item to the item list
        else --otherwise just remove 1 from the amount needed
          shoppingList[item.type].amount = shoppingList[item.type].amount - 1
        end
      end
    end
    return shoppingList
  end
end

--[[
--returns a list of items that are missing, if empty then all items are present
function tbx.checkInventory(shoppingList)
  if #tbx.groupClipboard > 0 then
    --loop through bags
    bagNo = 1
    for _, bag in pairs(Inspect.Item.Detail(Utility.Item.Slot.Inventory("bag"))) do
      --loop through each slot in the bag
      for slot = 1, bag.slots, 1 do
        local item = Inspect.Item.Detail(Utility.Item.Slot.Inventory(bagNo, slot))
        --if the item matches something in the shopping list
        if item ~= nil and shoppingList[item.type] ~= nil then
          if item.stack == nil then item.stack = 1 end --if the item has no stack value, set its stack to 1
          if shoppingList[item.type].amount <= item.stack then --if there are more items in the stack than needed
            shoppingList[item.type] = nil -- remove the item from the shopping list (we have enough)
            tbx.itemList[item.type] = item.id --add the item to the item list
          else --otherwise just remove the amount we have
            shoppingList[item.type].amount = shoppingList[item.type].amount - item.stack
          end
        end
      end
      bagNo = bagNo + 1
    end
    return shoppingList
  end
end
]]

function tbx.pasteGroup(pasteAtOriginalLoc)
  local shoppingList = tbx.getGroupShoppingList()
  local missingItems = tbx.checkSelected(shoppingList)
  
  if tbx.tableLength(missingItems) > 0 then
    print("Cannot construct - the following items are missing from selection:")
    for id, details in pairs(missingItems) do
      print(string.format("%s: %d", details.name, details.amount))
    end
  else
  
    for _, details in pairs(tbx.groupClipboard) do
      local item = table.remove(tbx.itemList[details.type],1)
      
      local newPlacement = {
        coordX = details.coordX,
        coordY = details.coordY,
        coordZ = details.coordZ,
        yaw = details.yaw,
        pitch = details.pitch,
        roll = details.roll,
        scale = details.scale,
      }
      
      if not pasteAtOriginalLoc then
        tbx.dbg("Pasting at player")
        local cp = tbx.getCentralPoint(tbx.groupClipboard)
        local player = Inspect.Unit.Detail("player")
        newPlacement.coordX = player.coordX + (details.coordX - cp.x) + 10
        newPlacement.coordY = player.coordY + (details.coordY - cp.y)
        newPlacement.coordZ = player.coordZ + (details.coordZ - cp.z)
      end
      
      --tbx.dbg("Pasting item %s", tbx.itemList[details.type].name)
      Command.Dimension.Layout.Place(item, newPlacement)
      --table.insert(tbx.itemQueue, {item = tbx.itemList[details.type], placement = newPlacement})
    end
    print(string.format("Item set loaded", name))
    
  end
  --tbx.queueEvent[1] = tbx.processQueue
  --table.insert (Event.Dimension.Layout.Update, {tbx.processQueue, "tbx", "Add items from queue"})
  --tbx.processQueue()
  --tbx.queuePaused = false
  --tbx.processQueue()
end

function tbx.printShoppingList(name)
  if name ~= nil and name ~= "" then
    if tbx.constructions[name] ~= nil then
        tbx.groupClipboard = tbx.constructions[name]
        local list = tbx.getGroupShoppingList()
        if list ~= nil and tbx.tableLength(list) > 0 then
          print("The following items are required for this construction:")
          for id, details in pairs(list) do
            print(string.format("%s: %d", details.name, details.amount))
          end
        else
          print("Could not print materials")
        end
    else
      print(string.format("Item set \"%s\" not found", name))
    end
  else
    print("You must select a set in order to print its materials")
  end
end

function tbx.importItemSet(name, data)
  if data ~= nil and data ~= "" then
    if name ~= nil and name ~= "" then
      local deserialized = tbx.deserializeTable(data)
      if deserialized ~= nil and #deserialized > 0 then
        tbx.constructions[name] = deserialized
        tbx.settings.set("savedConstructions", tbx.constructions)
        print(string.format("Item set \"%s\" imported", name))
      else
        print("There was an error reading the imported set. Please ensure the text entered is exactly as it was when exported")
      end
    else
      print("You must enter a name for the imported set")
    end
  else
    print("You must enter the set to be imported into the \"Import\" text box in order to import it")
  end
end

function tbx.exportItemSet(name)
  if name ~= nil and name ~= "" then
    if tbx.constructions[name] ~= nil then
        tbx.ui.window.constructions.exportText:SetText(tbx.serializeTable(tbx.constructions[name]))
        print(string.format("Item set \"%s\" exported", name))
    else
      print(string.format("Item set \"%s\" not found", name))
    end
  else
    print("You must select a set from the drop-down list in order to export it")
  end
end

--[[
function tbx.processQueue()
  if #tbx.itemQueue > 0 and not tbx.queuePaused then
    local item = table.remove(tbx.itemQueue, 1)
    Command.Dimension.Layout.Place(item.item, item.placement)
  else
    --tbx.queueEvent = function() end --remove the event listener
  end
end
]]
function tbx.pasteMultipleItemAttributes(x, y, z, yaw, pitch, roll, scale, xOffset, yOffset, zOffset, yawOffset, pitchOffset, rollOffset, scaleOffset, multiplyOffset)
  if #tbx.selectedItems > 0 then
  
    if xOffset == nil or xOffset == "" or not x then xOffset = 0 end
    if yOffset == nil or yOffset == "" or not y then yOffset = 0 end
    if zOffset == nil or zOffset == "" or not z then zOffset = 0 end
    if yawOffset == nil or yawOffset == "" or not yaw then yawOffset = 0 end
    if pitchOffset == nil or pitchOffset == ""  or not pitch then pitchOffset = 0 end
    if rollOffset == nil or rollOffset == "" or not roll then rollOffset = 0 end
    if scaleOffset == nil or scaleOffset == "" or not scale then scaleOffset = 0 end

    if not tonumber(xOffset) or
       not tonumber(yOffset) or
       not tonumber(zOffset) or
       not tonumber(yawOffset) or
       not tonumber(pitchOffset) or
       not tonumber(rollOffset) or
       not tonumber(scaleOffset) then
      print("Please enter numeric values only")
      return
    end
    
    for k, details in pairs(tbx.selectedItems) do
      if multiplyOffset then
        tbx.pasteItemAttributes(k, x, y, z, yaw, pitch, roll, scale, k*tonumber(xOffset), k*tonumber(yOffset), k*tonumber(zOffset), k*tonumber(yawOffset), k*tonumber(pitchOffset), k*tonumber(rollOffset), k*tonumber(scaleOffset))
      else
        tbx.pasteItemAttributes(k, x, y, z, yaw, pitch, roll, scale, xOffset, yOffset, zOffset, yawOffset, pitchOffset, rollOffset, scaleOffset)
      end
    end
  end
end

function tbx.pasteItemAttributes(index, x, y, z, yaw, pitch, roll, scale, xOffset, yOffset, zOffset, yawOffset, pitchOffset, rollOffset, scaleOffset)
  if tbx.selectedItems[index] ~= nil and tbx.clipboard ~= nil then
    
    local newPlacement = {}
    if x then newPlacement.coordX = tbx.clipboard.x + xOffset end
    if y then newPlacement.coordY = tbx.clipboard.y + yOffset end
    if z then newPlacement.coordZ = tbx.clipboard.z + zOffset end
    if yaw then newPlacement.yaw = tbx.clipboard.yaw + tbx.toRadians(yawOffset) end
    if pitch then newPlacement.pitch = tbx.clipboard.pitch + tbx.toRadians(pitchOffset) end
    if roll then newPlacement.roll = tbx.clipboard.roll + tbx.toRadians(rollOffset) end
    if scale then newPlacement.scale = tbx.clipboard.scale + scaleOffset end
    
    Command.Dimension.Layout.Place(tbx.selectedItems[index].id, newPlacement)
  
  elseif tbx.selectedItems[index] == nil then
    print("Please select an item in order to paste attributes")
  else
    print("You must copy an item's attributes before pasting")
  end
end

function tbx.round(num, dp)
  return tonumber(string.format("%." .. (dp or 0) .. "f", num))
end

function tbx.toRadians(num)
  return num * (math.pi / 180)
end

function tbx.toDegrees(num)
  return num * (180 / math.pi)
end

-- Necessary to get the number of items in a dictionary
-- '#' only supports contiguous integer-keyed tables :(
function tbx.tableLength(t)
  if t ~= nil then 
    local count = 0
    for _ in pairs(t) do count = count + 1 end
    return count
  else
    return 0
  end
end

function tbx.serializeTable(t)
  local s = ""
  for _, item in pairs(t) do
    if s ~= "" then s = string.concat(s, "|") end
    s = string.concat(s, tostring(item.name), ";")
    s = string.concat(s, tostring(item.type), ";")
    s = string.concat(s, tostring(item.coordX), ";")
    s = string.concat(s, tostring(item.coordY), ";")
    s = string.concat(s, tostring(item.coordZ), ";")
    s = string.concat(s, tostring(item.yaw), ";")
    s = string.concat(s, tostring(item.pitch), ";")
    s = string.concat(s, tostring(item.roll), ";")
    s = string.concat(s, tostring(item.scale))
  end
  return s
end

function tbx.deserializeTable(data)
  local t = {}
  for item, _ in string.gsplit(data, "|") do
    local itemTable = {}
    item = string.split(item, ";")
    if #item < 9 then return nil end --Check we have 9 attributes
    if not tonumber(item[3]) or --Check x, y, z, yaw, pitch, roll, scale are numbers
       not tonumber(item[4]) or
       not tonumber(item[5]) or
       not tonumber(item[6]) or
       not tonumber(item[7]) or
       not tonumber(item[8]) or
       not tonumber(item[9]) then
      return nil
    end
    itemTable.name = item[1]
    itemTable.type = item[2]
    itemTable.coordX = tonumber(item[3])
    itemTable.coordY = tonumber(item[4])
    itemTable.coordZ = tonumber(item[5])
    itemTable.yaw = tonumber(item[6])
    itemTable.pitch = tonumber(item[7])
    itemTable.roll = tonumber(item[8])
    itemTable.scale = tonumber(item[9])
    table.insert(t, itemTable)
  end
  return t
end
-- Command Handler
function tbx.commandHandler(command)
	tbx.dbg("Command received: %s", command)
  
  if command == "reset" then
    tbx.settings.set("windowPosX", 0)
    tbx.settings.set("windowPosY", 0)
    if tbx.ui.window then tbx.ui.window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0) end
    print("Position reset")
  else
    tbx.ui.toggleToolboxWindow()
  end
end

-- Debug
-- Prints a message if debug mode is enabled.
-- Works like string.format
function tbx.dbg(fmt, ...)
  if tbx.debug and fmt ~= nil then
    print(string.format("[DEBUG] " .. fmt, unpack({...})))
  end
end


tbx.main()